# PS2PK automates rendering pfb fonts 
# for emtex screen drivers
#
# encoding we get from psfonts.map
# afm information from afm.file
# pfb information from pfb.file
# fonts/scaling from dviscr.dlg
#
# this script should generate the following line
#@call ps2pk.bat <fontname> <res> <encoding-ifany>

# Get the environment variable from the system 
function env_var(v,    setlist) {
        
   while (("set" | getline  setlist ) > 0) {
        match(setlist,"=");
        vname = substr (setlist,1,RSTART-1);
        if (v == vname) { return (substr (setlist,RSTART+1) )}
   }
   return ("."); # default is current dir
}

BEGIN{ PSCONFIG = "TEXCONFIG"; # env. variable for looking for DVIPSCNF
       DVIPSCNF="psfonts.map"; # DVIPS font configuration file name
       PROGNAME = "@call ps2pk.bat"; # the font generating program 
       GENFILE = "mk-pkfon.bat"; # output file (for results)
}

BEGIN {
    v = env_var(PSCONFIG);
    flag = 0;

    vnum = split(v, vvec,";");
    for (i=1; i<=vnum; i++) {
        filenam = vvec[i] "\\" DVIPSCNF; # full path
        while ( (getline < filenam ) > 0) {
            ## next; <-- bd
            flag = 1;
            break;
        }
        close(filenam);
        if (flag) {break}
    }
}


# Scanning font info from external file (gentemp.mfj)

{
    if ($0 ~ "font") {
       print "->";
       gsub("[{};=]", "");
       FONTNAME = $1; sub("font","",FONTNAME);
       FONTRES = $2;  sub("mag","",FONTRES);

       enc = ""; # default is built-in encoding

       print FONTNAME;

       while ( (getline tmp < filenam ) > 0) {

          x = split(tmp, finfo, " ");

          if (finfo[1] == FONTNAME) { 
             if (tmp ~ "ReEncodeFont") {
                enc = finfo[x-1]; 
                enc = substr(enc,2);
             }
             print PROGNAME, FONTNAME, int((FONTRES * mode) + 0.5), enc > GENFILE;
          }
       }
       close(filenam);
    }
}


